﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
#if GDI
//using System.Drawing;
#endif
#if WPF
using System.Windows.Media.Imaging;
#endif
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MigraDoc.DocumentObjectModel;
using MigraDoc.DocumentObjectModel.Shapes;
using MigraDoc.DocumentObjectModel.Tables;
using MigraDoc.Rendering;

namespace BugSubmission
{
    class Program
    {
        static void Main()
        {
            // Create a new MigraDoc document
            Document document = new Document();
            //document.UseCmykColor = true;

            // Add a section to the document
            Section section = document.AddSection();

            // Add a paragraph to the section
            Paragraph paragraph = section.AddParagraph();

            paragraph.Format.Font.Color = Color.FromCmyk(100, 30, 20, 50);

            // Add some text to the paragraph
            paragraph.AddFormattedText("Hello, World!", TextFormat.Bold);

            //^^^ unchanged ^^^^

            //Add a table
            Table table = new Table();
            table.Borders.Width = 0.2;
            table.Borders.Color = Colors.LightGray;

            //Add Columns 
            for (int i = 0; i <= 2; i++)
            {
                table.AddColumn();
            }
            //Add Rows
            for (int i = 0; i <= 2; i++)
            {
                table.AddRow();
            }

            //toMerge format={col0,col1,...}
            //col format = row,mergedown-rows

            //2 out of these 3 columns will work
            string[] toMerge = { "0,1", "1,1"}; //ok
            //string[] toMerge = { "0,1", "", "1,1" }; //ok

            //>>> it is not not possible to mergedown in all columns <<<
            //string[] toMerge = { "0,1", "1,1","1,1" }; //no way
            //string[] toMerge = { "0,1", "0,1", "1,1" }; //no way

            // just the algorithm to translate above array to cell mergedown
            Cell cell;
            for (int i = 0; i <= toMerge.Count() - 1; i++)  //loop elements of toMerge
            {
                var toMergetmp = toMerge[i].Split('~');     //separate row elements 
                foreach (var element in toMergetmp)
                {
                    if (element != "")
                    {
                        string[] e = element.Split(',');    //separate cell number and mergedown number
                        cell = table.Rows[Int16.Parse(e[0])].Cells[i];  //address cell
                        cell.MergeDown = Int32.Parse(e[1]);             //and perform mergedown
                    }
                }
            }

            document.LastSection.Add(table);

#if GDI
            // Using GDI-specific routines.
            // Make sure to use "#if GDI" for any usings you add for platform-specific code.
            {
            }
#endif

#if WPF
            // Using WPF-specific routines.
            // Make sure to use "#if GDI" for any usings you add for platform-specific code.
            {
            }
#endif

            // Create a renderer for the MigraDoc document.
            PdfDocumentRenderer pdfRenderer = new PdfDocumentRenderer(true);

            // Associate the MigraDoc document with a renderer
            pdfRenderer.Document = document;

            // Layout and render document to PDF
            pdfRenderer.RenderDocument();

            // Save the document...
            const string filename = "HelloWorld.pdf";
            pdfRenderer.PdfDocument.Save(filename);
            // ...and start a viewer.
            Process.Start(filename);
        }
    }
}
